/*******************************************************************************************
*   MT-10T7                                                                      *
*  0.1                                                                               *
*  27  2005                                                               *
*  28  2005                                                             *
*                                                                *
*******************************************************************************************/

#include "mt-10t7.h"

//  
__flash char Decode[]={
(a|b|c|d|e|f),    //0 [0]
(b|c),            //1
(a|b|g|e|d),      //2
(a|b|c|d|g),      //3
(f|g|b|c),        //4
(a|f|g|c|d),      //5
(a|f|e|d|c|g),    //6
(a|b|c),          //7
(a|b|c|d|e|f|g),  //8
(a|b|c|d|g|f),    //9 [9]

(e|f|a|b|c|g),    //A [10]
(f|e|d|c|g),      //B
(a|f|e|d),        //C
(g|e|d|c|b),      //D
(a|f|e|d|g),      //E
(a|f|e|g),        //F
(a|f|g|b|c),      //G
(f|e|g|b|c),      //H
(c),              //I
(b|c|d),          //J
(d),              //K[ursor]
(f|e|d),          //L
(g),              //M[inus]
(e|g|c),          //N
(c|d|e|g),        //O
(a|b|g|f|e),      //P
(a|b|g|f|c),      //Q
(e|g),            //R
(a|f|g|c|d),      //S
(a),              //T( )
(f|e|d|c|b),      //U
(e|d|c),          //V [31]
(0)               //SPACE
};

//   ,  mode==ADDR_BYTE,   ;  mode==DATA_BYTE,   
void lcd_write_byte(char byte, char mode)
{
  if(mode==ADDR_BYTE)
  {
    // 
    A0=0;
    PORTD&=0xc3;
    PORTD|=((byte<<2) & 0x3c);
    WR1=1;
    __delay_cycles(0.000001*F_CLK);
    WR1=0;
  }
  else
  {
    // 
    A0=1;
    PORTD&=0xc3;
    PORTD|=((byte<<2) & 0x3c);
    WR1=1;
    __delay_cycles(0.000001*F_CLK);
    WR1=0;

    PORTD&=0xc3;
    PORTD|=((byte>>2) & 0x3c);
    WR1=1;
    __delay_cycles(0.000001*F_CLK);
    WR1=0;
  }
}

// 
void lcd_init(void)
{
  WR1=0;
  __delay_cycles(0.001*F_CLK);
  lcd_write_byte(0x0f,ADDR_BYTE);
  PORTD&=0xc3;
  DB0=1; //    
  A0=1;
  WR1=1;
  __delay_cycles(0.000001*F_CLK);
  WR1=0;
}

// 
void lcd_clear(void)
{
  lcd_write_byte(0,ADDR_BYTE);
  for(char i=0;i<10;i++)
      lcd_write_byte(0,DATA_BYTE);
  lcd_write_byte(0,ADDR_BYTE);
}

//   ,  dot=1,     
void lcd_putchar(char byte,char dot)
{
  if((byte<=57)&&(byte>=48)) byte-=48;
    else if((byte>=65)&&(byte<=86)) byte-=55;
  byte=Decode[byte];
  if(dot) byte|=(1<<DOT_MT); // ,  
  lcd_write_byte(byte, DATA_BYTE);
}

//   
void lcd_puts(char __flash *s, unsigned char cl_flag)
{
  if(cl_flag)
    lcd_clear();
  for(char i=0;i<strlen_P(s);i++) lcd_putchar(s[i],0);
}

//   unsigned int
void lcd_puts_ui(unsigned int ui)
{
  unsigned int i=1000;
  unsigned char zero_flag=1;
  do
    {
      if((ui/i) && zero_flag) zero_flag=0;
      if(!zero_flag) lcd_putchar((char)(ui/i+48),0);
      ui%=i;
      i/=10;
    }while(i);
}

